unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Math,
  TAGraph, TATools, TASeries, TATransformations, Types, TAChartUtils;

type

  TRange = array[0..1] of Integer;

  { TForm1 }

  TForm1 = class(TForm)
    Chart: TChart;
    ChartToolset: TChartToolset;
    ChartToolsetPanDragTool1: TPanDragTool;
    ChartToolsetZoomDragTool1: TZoomDragTool;
    procedure ChartExtentChanged(ASender: TChart);
    procedure FormCreate(Sender: TObject);
  private
    function  GetXAxisRange: TRange;
    function  GetMinMax(XRange: TRange): TRange;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  LSeries: TLineSeries;
  i: Integer;
begin
  LSeries := TLineSeries.Create(Chart);
  LSeries.AddXY(0, 50);
  for i := 1 to 100 do
    LSeries.AddXY(i, LSeries.GetYValue(i - 1) + Random(9) - 4);
  Chart.AddSeries(LSeries);
end;

function TForm1.GetXAxisRange: TRange;
var
  LExtent: TDoubleRect;
begin
  LExtent := Chart.CurrentExtent;
  Result[0] := Round(LExtent.a.x);
  Result[1] := Round(LExtent.b.x);
end;

function TForm1.GetMinMax(XRange: TRange): TRange;
var
  LMinValue, LMaxValue, i: Integer;
  LSeries: TLineSeries;
  LValue: Int64;
begin
  LMinValue := 1000;
  LMaxValue := -1000;
  LSeries := TLineSeries(Chart.Series[0]);
  for i := XRange[0] to XRange[1] do
    if (i > LSeries.MaxXValue) or (i < LSeries.MinXValue) then
      Continue
    else begin
      LValue := Round(LSeries.GetYValue(i));
      if LValue < LMinValue then LMinValue := LValue;
      if LValue > LMaxValue then LMaxValue := LValue;
    end;
  Result[0] := Min(100, LMinValue);
  Result[1] := Max(0,   LMaxValue);
end;

procedure TForm1.ChartExtentChanged(ASender: TChart);
var
  XRange, YRange: TRange;
  LExtent: TDoubleRect;
begin
  XRange := GetXAxisRange;
  YRange := GetMinMax(XRange);
  Caption := 'X[' + IntToStr(XRange[0]) + '..' + IntToStr(XRange[1]) + '] Y[' + IntToStr(YRange[0]) + '..' + IntToStr(YRange[1]) + ']';
  LExtent.coords[1] := XRange[0];
  LExtent.coords[2] := YRange[0];
  LExtent.coords[3] := XRange[1];
  LExtent.coords[4] := YRange[1];
  Chart.LogicalExtent := LExtent;
end;

end.

